﻿--[[
DiHook r2
Date: 2011-12-11T12:23:06Z
Author: cklausi
DiHook.lua
Shows all Dark Intents in your party or raid in the actionbar tooltip
]]--

local DiScan = {}
local DarkIntent = 80398

local function UnitHasBuff(unit, buff)
	for i=1, 40 do
		local name, _, _, _, _, _, expirationTime, source, _ = UnitBuff(unit, i)
		if (name == GetSpellInfo(buff)) then
			return true, _, _, expirationTime, source
		end
	end
	return false
end

local function DiScanner()
	DiScan = {}
	local party = ""
	local count = 1

	if(UnitHasBuff("pet", DarkIntent)) then
		local _, _, _, _, unitCaster = UnitHasBuff("pet", DarkIntent)
		table.insert(DiScan, UnitName(unitCaster)..";"..UnitName("pet"))
	end
	
	if(UnitInRaid("player")) then
		party = "raid"
		count = 40
	elseif(UnitInParty("player")) then
		party = "party"
		count = 4
	end

	if(party == "raid" or party == "party") then
		for i = 1, count, 1 do
			local _, _, _, _, unitCaster = UnitHasBuff(party..i, DarkIntent)
			if(unitCaster ~= "" and unitCaster ~= nil and unitCaster ~= false) then
				local name, _ = UnitName(party..i)
				local unitCaster, _ = UnitName(unitCaster)
				if(unitCaster ~= name) then
					if(name == nil) then name = " " end
					table.insert(DiScan, unitCaster..";"..name)
				end
			end
		end
	end

end

local function DiHook(tooltip)
	local _, _, SpellId = tooltip:GetSpell()
	if(SpellId == DarkIntent) then
		DiScanner()
		if(#(DiScan) > 0) then 
			tooltip:AddLine(" ", 1, 1, 1)
			tooltip:AddLine("Dark Intent Targets:", 1, 1, 1)
			for _, unitCaster in pairs(DiScan) do
				local diCaster, diTarget = strsplit(";", unitCaster)
				local _, englishClassTarget = UnitClass(diTarget)
				local _, englishClassCaster = UnitClass(diCaster)
				local fontColorTarget = {}
				local fontColorCaster = {}
				if(RAID_CLASS_COLORS[englishClassCaster] == false) then
					fontColorCaster["r"] = 1
					fontColorCaster["g"] = 1
					fontColorCaster["b"] = 1
				else
					fontColorCaster = RAID_CLASS_COLORS[englishClassCaster]
				end
				if(RAID_CLASS_COLORS[englishClassTarget] == false) then
					fontColorTarget["r"] = 1
					fontColorTarget["g"] = 1
					fontColorTarget["b"] = 1
				else
					fontColorTarget = RAID_CLASS_COLORS[englishClassTarget]
				end
				tooltip:AddDoubleLine(diTarget, "by "..diCaster, fontColorTarget["r"], fontColorTarget["g"], fontColorTarget["b"], fontColorCaster["r"], fontColorCaster["g"], fontColorCaster["b"])
			end
		end
	end
	tooltip:Show()
end

if GameTooltip:GetScript("OnTooltipSetSpell") then
	GameTooltip:HookScript("OnTooltipSetSpell", DiHook)
else
	GameTooltip:SetScript("OnTooltipSetSpell", DiHook)
end 
